/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/

module  beep(
    clk         ,
    rst_n       ,
    op_1_err    ,
    op_2_err    ,
    result_err  ,
    beep
    );

    parameter   CNT_1S  =   26'd5000_0000   ;
    parameter   CNT_WID =   26              ;  
    
    input                   clk         ;
    input                   rst_n       ;
    input                   op_1_err    ;
    input                   op_2_err    ;
    input                   result_err  ;

    output                  beep        ;

    reg                     beep        ;
    reg     [CNT_WID-1:0]   cnt_1s      ;
    wire                    add_cnt_1s  ;
    wire                    end_cnt_1s  ;




always @(posedge clk or negedge rst_n) begin 
    if (rst_n==0) begin
        cnt_1s <= 0; 
    end
    else if(add_cnt_1s) begin
        if(end_cnt_1s)
            cnt_1s <= 0; 
        else
            cnt_1s <= cnt_1s+1 ;
   end
end
assign add_cnt_1s = beep==0;
assign end_cnt_1s = add_cnt_1s  && cnt_1s == CNT_1S-1 ;


always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        beep <= 1'b1;
    end
    else if(op_1_err || op_2_err || result_err)begin
        beep <= 1'b0;
    end
    else if(end_cnt_1s)begin
        beep <= 1'b1;
    end
end

endmodule


