/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/

module  oper(
    clk         ,
    rst_n       ,
    key_num     ,
    key_vld     ,
    state_c     ,
    oper        
    );

    parameter   KEY_WID     =   4       ;
    parameter   STATE_WID   =   5       ;
    parameter   OP_1        =   5'b00001;
    parameter   OPER        =   5'b00010;
    
    input                   clk         ;
    input                   rst_n       ;
    input   [KEY_WID-1:0]   key_num ;
    input                   key_vld ;
    input   [STATE_WID-1:0] state_c     ;

    output  [KEY_WID-1:0]   oper        ;

    reg     [KEY_WID-1:0]   oper        ;
    wire                    key_op_en   ;

assign  key_op_en = (key_num==10 || key_num==11 || key_num==12 || key_num==13) && key_vld==1;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        oper <= 0;
    end
    else if(state_c==OP_1)begin
        oper <= 0;
    end
    else if(key_op_en==1)begin
        oper <= key_num;
    end
    else begin
        oper <= oper;
    end
end

endmodule

